/*-----------------------------------------------------------------------*
 Project: [Common]
 File: [CTR_Tick.cpp]

 Copyright (C) 2009 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
/******************************************************************
                        include t@C
*******************************************************************/
#include "CTR_Tick.h"
#include <nn/os.h>
using namespace nn::os;

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************
            OJ֐
*******************************************************************/
/*!--------------------------------------------------------*
 @brief  : CTR_TickInit()
 @param  : Ȃ
 @return : Ȃ
 @summary: Ȃ
*----------------------------------------------------------*/
void CTR_TickInit( void ){

}
/*!--------------------------------------------------------*
 @brief  : CTR_GetTick()
 @param  : Ȃ
 @return : Ȃ
 @summary: Tick̎擾
 @note   : ~bPʂŏo͂ : TIME_SET_MSEC
         :   bPʂŏo͂ : TIME_SET_USEC
*----------------------------------------------------------*/
unsigned long CTR_GetTick( void ){

    unsigned long ret = 0;

    Tick tick = Tick::GetSystemCurrent();
#ifdef TIME_SET_USEC
    ret =  (unsigned long)tick.ToTimeSpan().GetMicroSeconds();
#else
    ret =  (unsigned long)tick.ToTimeSpan().GetMilliSeconds();
#endif /* #ifdef TIME_SET_USEC */

    return ret;
}


#ifdef __cplusplus
}
#endif

