// ----------------------------------------------------------------------
// JNX
// ----------------------------------------------------------------------
// 2011.06.16:YUVΉ
// ----------------------------------------------------------------------
// GetYuvData֐ǉ
// ͉摜\̂ߏ㉺]ݒ肵Ăݒ
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn/os.h>
#include	<nn/camera.h>
#include	<nn/y2r.h>
#include	<string.h>

// ----------------------------------------------------------------------
// include original header
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlCamera.h"

//------------------------------------------------------------
// J̃CxgsȂXbh
//------------------------------------------------------------
void CameraThreadFunc( CCtrlCamera* pCamera )
{
    pCamera->CameraThreadFuncImpl();
}

// ----------------------------------------------------------------------
// CCtrlCamera::CCtrlCamera
// ----------------------------------------------------------------------
// e
//   RXgN^
//   J̏s܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CCtrlCamera::CCtrlCamera()
{
	m_width				= 0;
	m_height			= 0;

    // J̏Ă邩𔻕ʂtO
    s_IsCameraInitialized = false;

    // JXbhҋ@Ԃɂ邽߂̃tO
    s_IsCameraThreadSleep = false;

    // JXbhI邽߂̃tO
    s_IsCameraThreadEnd = false;

    // t[[gύX鎞̃tO
    s_SwitchFrameRateFlag = false;

    // Y2Rϊ҂̉摜邩ǂ̃tO
    s_ExistYuvImage = false;

}

// ----------------------------------------------------------------------
// CCtrlCamera::~CCtrlCamera
// ----------------------------------------------------------------------
// e
//   fXgN^
//   JJ܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CCtrlCamera::~CCtrlCamera()
{
}


// ----------------------------------------------------------------------
// CCtrlCamera::InitializeCamera
// ----------------------------------------------------------------------
// e
//   JNX̏s܂B
// ----------------------------------------------------------------------
// 
//   eCamType		[ I ] J̃^Cvw肵܂B
//   eCamSize		[ I ] J̉摜TCYw肵܂B
//   eCamRate		[ I ] J̃t[[gw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   0Ԃ܂B
// ----------------------------------------------------------------------
int CCtrlCamera::InitializeCamera(CameraSelect select, Size size, FrameRate rate)
{
	PRINT_OUT("Init OK\n");

	switch(size)
	{
	case SIZE_VGA:			// SIZE_VGA 640x480 
		m_width  = 640;
		m_height = 480;
		break;

	case SIZE_QVGA:			// SIZE_QVGA 320x240 
		m_width  = 320;
		m_height = 240;
		break;

	case SIZE_QQVGA:		// SIZE_QQVGA 160x120
		m_width  = 160;
		m_height = 120;
		break;

	case SIZE_DS_LCD:
		m_width  = 256;
		m_height = 192;
		break;
	}

    m_Size = size;
    m_FrameRate = rate;
    m_Select = select;

    // J̏pXbh̋N
    InitializeCameraThread();


	return 0;
}

// ----------------------------------------------------------------------
// CCtrlCamera::FinalizeCamera
// ----------------------------------------------------------------------
// e
//   J̔js܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CCtrlCamera::FinalizeCamera()
{
    // Jp̃XbhI
    FinalizeCameraThread();

    // RGB obt@̉
}


// ======================================================================================
// JXbh֐
// ======================================================================================
#if 0 // {Tvł́ASleep͍lȂ
//------------------------------------------------------------
// X[v/JڑȌ(CXbhĂ΂܂)
//------------------------------------------------------------
void CCtrlCamera::PrepareTransitionCallback(void)
{
    // JXbhIĂȂꍇ͑ҋ@ԂɈڍs܂
    if (!s_IsCameraThreadEnd)
    {
        // JXbhɑҋ@Ԃւ̈ڍsʒm (CameraThreadFunc )
        s_IsCameraThreadSleep = true;

        // JXbhWaitAnyŃubNȂ悤ɃVOi (CameraThreadFunc )
        s_CameraBufferErrorEvent.Signal();

        // JXbhҋ@ԂɂȂ̂ҋ@ (CameraThreadFunc )
        s_CameraThreadSleepAckEvent.Wait();
    }
}

//------------------------------------------------------------
// X[v/Jڂ̌̕A(CXbhĂ΂܂)
//------------------------------------------------------------
void CCtrlCamera::AfterTransitionCallback(void)
{
    // JXbhIĂȂꍇ͑ҋ@Ԃ܂
    // AvÎ߂̕A͂ł͉ɃJXbh̏Iɂ܂܂B
    if (!s_IsCameraThreadEnd && !TransitionHandler::IsExitRequired())
    {
        // JXbhN߂ɃVOi (CameraThreadFunc )
        s_CameraThreadAwakeEvent.Signal();
    }
}
#endif
//-----------------------------------------------------
// JXbh̋N
//-----------------------------------------------------
void CCtrlCamera::InitializeCameraThread(void)
{
    s_CameraThreadSleepAckEvent.Initialize(false);
    s_CameraThreadAwakeEvent.Initialize(false);
    s_CameraBufferErrorEvent.Initialize(false); // ҋ@Ԃ̕AɎgp

#if 0 // Sleep͖{Tvł͍lȂ
    TransitionHandler::SetPrepareSleepCallback(PrepareTransitionCallback);
    TransitionHandler::SetAfterSleepCallback(AfterTransitionCallback);
    TransitionHandler::SetPrepareHomeButtonCallback(PrepareTransitionCallback);
    TransitionHandler::SetAfterHomeButtonCallback(AfterTransitionCallback);
#endif
    // ƂŗDxύX邽߂ɃCXbh̗DxoĂ
    s_MainThreadPriority = nn::os::Thread::GetCurrentPriority();

    // Jp̃Xbh𐶐
    //   ͗DxCXbhႭݒ
    //   IɗDxCXbh荂ύX
    s_CameraThread.StartUsingAutoStack(
        CameraThreadFunc, 
        this, 
        4096,
        s_MainThreadPriority + 3);
}

//-----------------------------------------------------
// JXbh̏I
//-----------------------------------------------------
void CCtrlCamera::FinalizeCameraThread(void)
{
    // JpXbh̔j
    s_IsCameraThreadEnd = true;         // ItO𗧂Ă
    s_CameraThreadAwakeEvent.Signal();  // X[vԂŎ~܂Ȃ悤ɃVOi
    s_CameraBufferErrorEvent.Signal();  // JXbh WaitAny Ŏ~܂Ȃ悤ɃVOi
    s_CameraThread.Join();              // Xbh̏I҂
    s_CameraThread.Finalize();          // Xbh̔j

#if 0 // Sleep͖{Tvł͍lȂ
    TransitionHandler::SetPrepareSleepCallback(NULL);
    TransitionHandler::SetAfterSleepCallback(NULL);
    TransitionHandler::SetPrepareHomeButtonCallback(NULL);
    TransitionHandler::SetAfterHomeButtonCallback(NULL);
#endif
    s_CameraThreadSleepAckEvent.Finalize();
    s_CameraThreadAwakeEvent.Finalize();
}

// ======================================================================================
// J/Y2R ֐
// ======================================================================================
//-----------------------------------------------------
// J̏
//-----------------------------------------------------
void CCtrlCamera::SetupCamera()
{
    // JLv`[Jn܂ł
    // L̊֐ɎsKvB
    //   (1) nn::camera::Initialize()   JCȕ
    //   (2) nn::camera::Activate()     gpJN
    //   (3) nn::camera::SetReceiving() ]Jn
    //   (4) nn::camera::StartCapture() Lv`Jn

    nn::Result result;

    // JCȕ
    while (true)
    {
        // ItOĂ甲܂
        if (s_IsCameraThreadEnd)
        {
            return;
        }

        result = nn::camera::Initialize();
        if (result.IsSuccess())
        {
            break;
        }
        else if (result == nn::camera::ResultFatalError())
        {
            // J̍ċNɎs
            NN_PANIC("Camera has broken.\n");
        }
        else if (result == nn::camera::ResultUsingOtherProcess())
        {
            // vZXŃJgp
            NN_PANIC("Camera is using by other process.\n");
        }
        else if (result == nn::camera::ResultAlreadyInitialized())
        {
            // ς݂̂ߓɏ͍sȂ
            NN_LOG("Camera is already initialized.\n");
            break;
        }
        else if (result == nn::camera::ResultIsSleeping())
        {
            // ҋ@ԂɂȂvꍇ͏I܂ŃubN܂B
            if (s_IsCameraThreadSleep)
            {
                s_IsCameraThreadSleep = false;
                // JXbhҋ@ԂɂȂƂʒm (Sleep, Home )
                s_CameraThreadSleepAckEvent.Signal();

                // Xbh̕AVOi܂őҋ@ (Sleep, Home )
                s_CameraThreadAwakeEvent.Wait();
            }
            else
            {
                // vȂꍇłԊuăgC邽߈莞ԃubN܂B
                nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMilliSeconds(10));
            }
            // gC܂
            NN_LOG("ShellClose: Retry camera initialization\n");
        }
    }

    // J̐ݒ
    while (true)
    {
        // ItOĂ甲܂
        if (s_IsCameraThreadEnd)
        {
            nn::camera::Finalize();
            return;
        }
        result = InitializeCameraSetting();
        if (result.IsSuccess())
        {
            break;
        }
        else if (result == nn::camera::ResultFatalError())
        {
            NN_PANIC("Camera has broken.\n");
        }
        else if (result == nn::camera::ResultIsSleeping())
        {
            // ҋ@ԂɂȂvꍇ͏I܂ŃubN܂B
            if (s_IsCameraThreadSleep)
            {
                s_IsCameraThreadSleep = false;
                // JXbhҋ@ԂɂȂƂʒm (Sleep, Home )
                s_CameraThreadSleepAckEvent.Signal();

                // Xbh̕AVOi܂őҋ@ (Sleep, Home )
                s_CameraThreadAwakeEvent.Wait();
            }
            else
            {
                // vȂꍇłԊuăgC邽߈莞ԃubN܂B
                nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMilliSeconds(10));
            }
            // gC܂
            NN_LOG("ShellClose: Retry camera setting\n");
        }
    }

    InitializeY2r();        // Y2R Cu֘Ȁ
    InitializeResource();   // \[X̐ݒ

    // ÎŗDxCXbh荂lɕύX܂
    nn::os::Thread::ChangeCurrentPriority(s_MainThreadPriority - 3);

    s_IsCameraInitialized = true;
}

//-----------------------------------------------------
// J ݒ
//-----------------------------------------------------
nn::Result CCtrlCamera::InitializeCameraSetting(void)
{
    // JLv`摜TCY̐ݒ
    NN_UTIL_RETURN_IF_FAILED(
        nn::camera::SetSize(
            m_Select,                // ݒΏۂƂȂJ
            m_Size,                  // ݒ肷J̉𑜓x
            nn::camera::CONTEXT_A)); // ݒ𔽉fReLXg

    // t[[g̐ݒ
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetFrameRate( m_Select, m_FrameRate));

    // ㉺]
    NN_UTIL_RETURN_IF_FAILED(nn::camera::FlipImage( m_Select, FLIP_REVERSE, CONTEXT_BOTH));

    // g~O̐ݒ
    //   g~Osꍇɂ́Aeg~OɊւ
    //   ֐̌Ăяo StartCapture() OɌĂяo
    //   KvB
    nn::camera::SetTrimming(CAMERA_PORT, false);

    // ]oCg̐ݒ
    //   {fł̓oCgŐݒ肵Ă邪A]oCgCŐݒ肷ꍇ́A
    //   nn::camera::GetMaxLines() ōő]oCg擾Ann::camera::SetTransferLines() 
    //   ݒ肷鎖\BA]oCgɂ͏̂ŏڂ́A
    //   vO~O}jAVXe҂́u6.4.3 Lv`̐ݒv
    //   u6.4.3 Lv`̐ݒvQƂ̂ƁB
    s_YuvTransferUnit = nn::camera::GetMaxBytes(
        m_width,     // ]摜̕(g~Oꍇ̓g~O̕)
        m_height);   // ]摜̍(g~Oꍇ̓g~O̍)
    nn::camera::SetTransferBytes(
        CAMERA_PORT,        // ΏۂƂȂ|[g
        s_YuvTransferUnit,  // ]oCg
        m_width,            // ]摜̕(g~Oꍇ̓g~O̕)
        m_height);          // ]摜̍(g~Oꍇ̓g~O̍)

    // J̏o̓f[^ɓK Y2R ̕ϊW擾
    //   Y2ȐɎgplłB
    //   Y2RgpȂꍇ͕svłB
    NN_UTIL_RETURN_IF_FAILED(nn::camera::GetSuitableY2rStandardCoefficient(&s_Coefficient));

	// Be[h				0 (␳)
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetPhotoMode(SELECT_CAMERA, PHOTO_MODE_NORMAL));

	// I[gzCgoX	OFF
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetAutoWhiteBalance(SELECT_CAMERA, false));  // 

	// Io@\				OFF
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetAutoExposure(SELECT_CAMERA, false));      // 

	// Io					0
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetExposure(SELECT_CAMERA, 0));

	// zCgoX			2 (WF Light)
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetWhiteBalance(SELECT_CAMERA,WHITE_BALANCE_WHITE_FLUORESCENT_LIGHT)); 

	// N					0
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetSharpness(SELECT_CAMERA,0));

	// RgXg				4 (p^[5)
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetContrast(SELECT_CAMERA,CONTRAST_PATTERN_05));

	// ӌʔ				0 (normal)
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetLensCorrection(SELECT_CAMERA,LENS_CORRECTION_ON_70));

    // mCYtB^
    NN_UTIL_RETURN_IF_FAILED(nn::camera::SetNoiseFilter(SELECT_CAMERA, true));        // L

    // JN
    //   {֐ɂăJW[NɁAStartCapture ֐
    //   ĂяoƂŉ摜̃Lv`JnB
    NN_UTIL_RETURN_IF_FAILED(nn::camera::Activate(SELECT_CAMERA));

    return nn::ResultSuccess();
}  //SetupCamera()

//------------------------------------------------------------
// Y2R Cȕݒ
//------------------------------------------------------------
void CCtrlCamera::InitializeY2r(void)
{
    // Y2R Cȕ
    if (!nn::y2r::Initialize())
    {
        NN_PANIC("Y2R is using by other process.\n");
    }

    // ϊ̏ꍇAݒłȂ̂ŁAIɋIB
    nn::y2r::StopConversion();
    while (nn::y2r::IsBusyConversion())
    {
        // ϊI܂ő҂
        nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMicroSeconds(100));
    }

    // Event ̏
    s_Y2rEndEvent.Initialize(false);

    // ̓tH[}bg̐ݒ
    nn::y2r::SetInputFormat(Y2R_INPUT_FORMAT);

    // o̓tH[}bg̐ݒ
    nn::y2r::SetOutputFormat(Y2R_OUTPUT_FORMAT);

    // o̓f[^̉]px̐ݒ
    nn::y2r::SetRotation(nn::y2r::ROTATION_NONE);   // ]

    // o̓f[^̃At@l̐ݒ
    //   RGB 24bit ł̓At@͎gpȂAIɏB
    nn::y2r::SetAlpha(0xFF);

    // o̓obt@̃f[^̕ѕ̐ݒ
    nn::y2r::SetBlockAlignment(Y2R_BLOCK_ALIGNMENT);

    // Y2R ϊE]̊ʒm󂯂邩ǂݒ
    nn::y2r::SetTransferEndInterrupt(true);
    nn::y2r::GetTransferEndEvent(&s_Y2rEndEvent);

    // ̓f[^ 1 C̕ݒ
    nn::y2r::SetInputLineWidth(m_width);

    // ̓f[^̏c̃Cݒ
    nn::y2r::SetInputLines(m_height);

    // WIȕϊW̐ݒ
    //   ACTR ɓڂJW[ύX\
    //   B̂߁A̕ϊWw肷̂ł͂ȂA
    //   GetSuitableY2rStandardCoefficient ֐ɂăJ
    //   ϊW擾āAݒ肷邱Ƃ𐄏B
    nn::y2r::SetStandardCoefficient(s_Coefficient);
}  //InitializeY2r()

//------------------------------------------------------------
// CAMERA/Y2R ̏ɕKvȃ\[X̊m
//------------------------------------------------------------
void CCtrlCamera::InitializeResource(void)
{
    // NeBJZNV
    s_CsYuvSwap.Initialize();

    // JCu擾Cxg
    s_CameraRecvEvent.Initialize(false);
    s_CameraVsyncEvent.Initialize(false);

    // obt@G[ʒm̂߂̃Cxg
    //   J̃f[^]ɎsƂ(FIFO ꂽƂ)
    //   obt@G[ʒmB
    nn::camera::GetBufferErrorInterruptEvent(&s_CameraBufferErrorEvent, CAMERA_PORT);

    // J V uNʒm̂߂̃Cxg
    //   V uNł́A]t[[ǧvZA
    //   J̐ݒύXsB
    nn::camera::GetVsyncInterruptEvent(&s_CameraVsyncEvent, CAMERA_PORT);

    // J摜f[^( YUV f[^ )̓]pobt@m
    s_YuvBufferSize = nn::camera::GetFrameBytes(m_width, m_height);
    for (s32 i = 0; i < YUV_BUFFER_NUM; i++)
    {
        NN_ASSERT(!s_pYuvBuffer[i]);
        s_pYuvBuffer[i] = static_cast<u8*>(OS_MALLOC_EX(s_YuvBufferSize, ALIGNMENT_SIZE));
        std::memset(s_pYuvBuffer[i], 0, s_YuvBufferSize);
    }
    s_YuvBufferIndexCapturing = 0;
    s_YuvBufferIndexLatestCaptured = YUV_BUFFER_NUM - 1;
    s_YuvBufferIndexTransmitting = YUV_BUFFER_NUM - 1;

    // J摜 Y2R ϊ( RGB f[^ )̓]pobt@m
    s_RgbBufferSize = nn::y2r::GetOutputImageSize(m_width, m_height,
        Y2R_OUTPUT_FORMAT);
    NN_ASSERT(!s_pRgbBuffer);
    s_pRgbBuffer = static_cast<u8*>(OS_MALLOC_EX(s_RgbBufferSize, ALIGNMENT_SIZE));
    std::memset(s_pRgbBuffer, 0, s_RgbBufferSize);
} //InitializeResource()

//------------------------------------------------------------
// CAMERA/Y2R ̏ɕKvȃ\[X̉
//------------------------------------------------------------
void CCtrlCamera::FinalizeResource(void)
{
    // q[v̉
    for (s32 i = 0; i < YUV_BUFFER_NUM; i++)
    {
        NN_ASSERT(s_pYuvBuffer[i]);
        OS_FREE(s_pYuvBuffer[i]);
    }
    NN_ASSERT(s_pRgbBuffer);
    OS_FREE(s_pRgbBuffer);

    // JCu擾Cxg̔j
    s_CameraRecvEvent.Finalize();
    s_CameraBufferErrorEvent.Finalize();
    s_CameraVsyncEvent.Finalize();

    // NeBJZNV̔j
    s_CsYuvSwap.Finalize();
}  //FinalizeResource()



//------------------------------------------------------------
// J̃CxgsȂXbh
//------------------------------------------------------------
void CCtrlCamera::CameraThreadFuncImpl( void )
{
    // J̏
    SetupCamera();

    // J̏ɃXbhIvꍇ͔
    if (s_IsCameraThreadEnd)
    {
        return;
    }

    // J̏NƃLv`ݒ
    StartCameraCapture();

    // ----------------------------------------
    // Cxgʏ
    enum
    {
        EVENT_RECV,     // J̓]
        EVENT_ERROR,    // obt@G[A듮ɂċN
        EVENT_VSYNC,    // V uN荞

        EVENT_MAX
    };
    nn::os::WaitObject* pEvent[EVENT_MAX];

    // eCxg̓o^
    pEvent[EVENT_RECV] = &s_CameraRecvEvent;
    pEvent[EVENT_ERROR] = &s_CameraBufferErrorEvent;
    pEvent[EVENT_VSYNC] = &s_CameraVsyncEvent;

    while (1)
    {
        // œo^ꂩ̃Cxgҋ@
        //   SetReceiving() ĂԂƂŁA]IʒmCxg
        //   NAĂ܂߁A]̍ĐݒsCxĝA
        //   xɎŝ͂ǂꂩ 1 ɂĂB
        if (s_IsCameraThreadEnd)
        {
            NN_LOG("before WaitAny\n");
        }
        s32 eventType = nn::os::WaitObject::WaitAny(pEvent, EVENT_MAX);
        if (s_IsCameraThreadEnd)
        {
            NN_LOG("after WaitAny\n");
        }

        // ----------------------------------------
        // XbhI
        if (s_IsCameraThreadEnd)
        {
            StopCameraCapture();
            break;
        }
        // ----------------------------------------
        // Xbhҋ@
#if 0
        if (s_IsCameraThreadSleep)
        {
            s_IsCameraThreadSleep = false;

            // J̃Lv`~
            StopCameraCapture();

            // JXbhX[vҋ@ԂɂȂƂʒm (Sleep, Home )
            s_CameraThreadSleepAckEvent.Signal();

            // Xbh̃X[vAVOi܂őҋ@ (Sleep, Home )
            NN_LOG("-Sleep camera thread.\n");
            s_CameraThreadAwakeEvent.Wait();
            NN_LOG("-Awake camera thread.\n");

            // ----------------------------------------
            // X[vȀ
            // VsyncCxgVOiĂ\̂ňUNA
            s_CameraVsyncEvent.ClearSignal();

            // Iö҂JE^Zbg
            s_FrameCountForStabilize = 0;

            // obt@G[̎dg݂𗘗păLv`ĊJ
            s_CameraBufferErrorEvent.Signal();
            continue;
        }
#endif
        switch (eventType)
        {
        case EVENT_RECV:
            // J]
            {
                // ̃t[̓]̐ݒ
                CameraRecvFunc();

                // Y2R ϊ̎s˗
                s_ExistYuvImage = true;
            }
            break;

        case EVENT_ERROR:
            // obt@G[A듮ɂċNAX[v/Jڌ̍ċN
            {
                // G[ɂ̓Lv`~Ă̂ŁA
                // ]Đݒ肵ALv`ĊJB
                StartCameraCapture();
            }
            break;

        case EVENT_VSYNC:
            // V uN荞
            {
                //   t[[gɌ炸AJ̐ݒύX
                //   ]sĂȂ V uN荞ݔɍsB
                CameraVsyncFunc();
            }
            break;

        default:
            {
                NN_LOG("Illegal event\n");
            }
            break;
        } //switch

    } //while

    {
        // CAMERA/Y2R ̏I
        //   ȉ̎菇ŏIsȂ΁AHOME j[
        //   TEh̃mCY\B
        nn::y2r::StopConversion();                      // (1) Y2R ϊ~
        nn::camera::StopCapture(CAMERA_PORT);           // (2) Lv`̒~
        nn::camera::Activate(nn::camera::SELECT_NONE);  // (3) SJX^oCԂ
        nn::camera::Finalize();                         // (4) JI
        nn::y2r::Finalize();                            //     Y2R I
    }
    {
        // CAMERA/Y2R Ɏgp郊\[X
        FinalizeResource();
    }
} //CameraThreadFunc()

//------------------------------------------------------------
// f[^]̖{
//------------------------------------------------------------
void CCtrlCamera::CameraRecvFunc(void)
{
    {
        // ݐ̃obt@؂ւ
        //   ǂݍ݃obt@̐؂ւ (Y2rConversion) 
        //   dȂȂ悤ɃubNB
        nn::os::CriticalSection::ScopedLock sl(s_CsYuvSwap);
        s_YuvBufferIndexLatestCaptured = s_YuvBufferIndexCapturing;
        do
        {
            // Oobt@̃CfbNX؂ւ
            if ((++s_YuvBufferIndexCapturing) >= YUV_BUFFER_NUM)
            {
                s_YuvBufferIndexCapturing = 0;
            }
        } while (s_YuvBufferIndexCapturing == s_YuvBufferIndexTransmitting);
    }

    // ̃t[̓]ݒ
    nn::camera::SetReceiving(
        &s_CameraRecvEvent,                         // ]ɃVOiCxg
        s_pYuvBuffer[s_YuvBufferIndexCapturing],    // ǂݍ񂾉摜f[^̓]
        CAMERA_PORT,                                // ǂݍݑΏۂ̃|[g
        s_YuvBufferSize,                            // Pt[̃TCY(]ƂȂTCY)
        s_YuvTransferUnit);                         // ɓ]TCY
} //CameraRecvFunc()

void CCtrlCamera::CameraVsyncFunc(void)
{
    //   t[[gɌ炸AJ̐ݒύX
    //   ]sĂȂ V uN荞ݔɍsB
    //   <TODO>
}

//------------------------------------------------------------
// JLv`̊Jn
//------------------------------------------------------------
void CCtrlCamera::StartCameraCapture(void)
{
    // obt@AG[tONA
    nn::camera::ClearBuffer(CAMERA_PORT);

    // f[^]
    CameraRecvFunc();

    // Lv`Jn
    nn::camera::StartCapture(CAMERA_PORT);

} // StartCameraCapture()

//------------------------------------------------------------
// JLv`̒~
//------------------------------------------------------------
void CCtrlCamera::StopCameraCapture(void)
{
    // Lv`~
    nn::camera::StopCapture(CAMERA_PORT);

    // ݒ肵Ăt[[g 1 t[̎(~b)vZ
    s32 timeout = 1000 / m_FrameRate;
    s32 cnt = 0;
    while (nn::camera::IsBusy(CAMERA_PORT))
    {
        // {̕̃^C~OɂẮAIsBusy()  true 
        // ԂԂɂȂ\B̂߁AX[vɈڍs
        // ̏ꍇɂ̏ԂɂȂƁA[v甲ȂȂ
        // X[vɈڍsȂȂB
        // ł̓^CAEg݂邱ƂŁA[vB
        // ʏAIsBusy  true ɂȂ͍̂őł 1 t[Ȃ̂ŁA
        // ^CAEgԂ 傫߂ 1 t[̎Ԃɐݒ肵ĂB
        nn::os::Thread::Sleep(nn::fnd::TimeSpan::FromMilliSeconds(1));
        if (++cnt > timeout)
        {
            NN_LOG("Busy timeout\n");
            break;
        }
    }
    // obt@AG[tONA
    nn::camera::ClearBuffer(CAMERA_PORT);
} // StopCameraCapture()

//------------------------------------------------------------
// Y2R ւ̓]ƕϊ
//------------------------------------------------------------
bool CCtrlCamera::Y2rConversion(void)
{
    // ***  ***
    // Y2R ɂ̓n[hEFAsAJ Y2R 𓯎ɎgpƂA
    // J̃obt@G[̔̕AɂāA^C~Oˑ
    // Y2R ]nOAbv\B
    // ̂߁Ann::y2r::GetTransferEndEvent Ŏ擾ϊCxg
    // i Signal Ȃ\B
    // Ƒ΍̏ڍׂɂẮAy2r ̊֐t@XQƂ̂ƁB
    //
    // {Tvł́ALCxg Wait Ƀ^CAEgA
    // ^CAEgꍇɂ́AgCsĂB
    // *** ӈȏ ***

    {
        // J̓ǂݏoobt@؂ւ
        //   ݃obt@̐؂ւ(CameraRecvFunc)ƏdȂȂ悤ɃubNB
        nn::os::CriticalSection::ScopedLock sl(s_CsYuvSwap);

        // J擾Iobt@ϊΏۂ
        s_YuvBufferIndexTransmitting = s_YuvBufferIndexLatestCaptured;
    }

    s32 cnt = 0;
    while (true)
    {
        // Y2R ͉̓摜(YUV)̓]ݒ
        //   YUVf[^Y2RɏށB]Pʂ 1 C̃f[^ƂȂB
        nn::y2r::SetSendingYuv(
            s_pYuvBuffer[s_YuvBufferIndexTransmitting], // ]f[^
            s_YuvBufferSize,                            // ]鍇vTCY
            nn::camera::GetLineBytes(m_width));  // 1̓]TCY(1C)

        // Y2R ̏o͉摜(RGB)̓]ݒ
        //   RGBf[^ Y2RǂݍށB1̓]TCY̓ptH[}X
        //   グ邽߂ɁA8 C̃TCYw肷邱Ƃ𐄏B
        s16 yuvTransferUnit = m_width * 8 * GetOutputFormatBytes(Y2R_OUTPUT_FORMAT);
        nn::y2r::SetReceiving(
            s_pRgbBuffer,                   // ϊꂽ RGB f[^̓Ǎ
            s_RgbBufferSize,                // ]鍇vTCY
            yuvTransferUnit);               // ̓]TCY

        // Y2RϊJn
        nn::y2r::StartConversion();

        // Y2R ϊCxg̒ʒmҋ@
        //   1̉摜̕ϊIOɎ̕ϊ̂߂̃f[^]
        //   sȂƓ]fĂ܂̂ŁAY2R ϊ̏I҂B
        //   ȂAY2R nOAbvs̑΍̂߁AϊI
        //   鎞Ԃ蒷߂̃^CAEgĂB
        //   ϊɂ̂̎Ԃ́Ay2r ֐t@XQƂ̂ƁB
        //if (s_Y2rEndEvent.Wait(nn::fnd::TimeSpan::FromMilliSeconds(10)))
        if (s_Y2rEndEvent.Wait(nn::fnd::TimeSpan::FromMilliSeconds(100)))
        {
            // ϊɐ
            return true;
        }
        else
        {
            // ϊɎs

            NN_LOG("Y2R may have hung up.\n");

            nn::y2r::StopConversion();  // ϊI

            // Aŉxs邱Ƃ͂߂ċHA
            // IɁA[v𔲂鏈ĂB
            if (++cnt >= 2)
            {
                // ̎̕ϊj
                return false;
            }
            // ^CAEĝŃgC
        }
    } //while(true)
} //Y2rConversion()

//------------------------------------------------------------
// YUVRGBf[^̎擾
//------------------------------------------------------------
void	CCtrlCamera::Receive(u8* rgbBuffer, CTxtWinDebugTimer& timer )
{
    if (s_ExistYuvImage) {
        s_ExistYuvImage = false;
        // J̓]CxgVOi̎̂
        // Y2R ϊs
        timer.TimerStart(0);
        if (Y2rConversion()) {
            std::memcpy( rgbBuffer, s_pRgbBuffer, s_RgbBufferSize);
        }
        timer.TimerEnd(0);
    }
}

// ----------------------------------------------------------------------
// SetExporse
// ----------------------------------------------------------------------
// e
//   Ioʂw肵܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] -5 ` 5̒lw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetExporse(int n)
{
	nn::camera::CTR::SetExposure(SELECT_IN1, n);
}

// ----------------------------------------------------------------------
// SetAutoExporse
// ----------------------------------------------------------------------
// e
//   Io@\̗LEݒ肵܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0() / 1(L)w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetAutoExporse(int n)
{
	bool bSet = (n > 0) ? true: false;
	nn::camera::CTR::SetExposure(SELECT_IN1, bSet);
}

// ----------------------------------------------------------------------
// SetSharpness
// ----------------------------------------------------------------------
// e
//   Nxw肵܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] -4 ` 5̒lw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetSharpness(int n)
{
	nn::camera::CTR::SetSharpness(SELECT_IN1, n);
}

// ----------------------------------------------------------------------
// SetPhotoMode
// ----------------------------------------------------------------------
// e
//   Be[hݒ肵܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 4̒lw肵܂B
//                    0:␳
//                    1:l
//                    2:i
//                    3:Î
//                    4:Be(QR)
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetPhotoMode(int n)
{
	PhotoMode mode = PHOTO_MODE_NORMAL;
	switch(n)
	{
	case 0:mode = PHOTO_MODE_NORMAL;	break;
	case 1:mode = PHOTO_MODE_PORTRAIT;	break;
	case 2:mode = PHOTO_MODE_LANDSCAPE;	break;
	case 3:mode = PHOTO_MODE_NIGHTVIEW;	break;
	case 4:mode = PHOTO_MODE_LETTER;	break;
	case 5:mode = PHOTO_MODE_MAX;		break;
	default :return;
	}

	nn::camera::CTR::SetPhotoMode(SELECT_IN1, mode);
}

// ----------------------------------------------------------------------
// GetPhotoModeStr
// ----------------------------------------------------------------------
// e
//   Be[h̕\p擾܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 4̒lw肵܂B
//                    0:␳
//                    1:l
//                    2:i
//                    3:Î
//                    4:Be(QR)
//   str		[ O ] 擾i[܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void GetPhotoModeStr(int n, char* str)
{
	switch(n)
	{
	case PHOTO_MODE_NORMAL:		sprintf(str, "Normal");		break;	// ␳Ȃ 
	case PHOTO_MODE_PORTRAIT:	sprintf(str, "Portrait");	break;	// l 
	case PHOTO_MODE_LANDSCAPE:	sprintf(str, "Landscape");	break;	// i 
	case PHOTO_MODE_NIGHTVIEW:	sprintf(str, "Night view");	break;	// Î 
	case PHOTO_MODE_LETTER:		sprintf(str, "Letter(QR)");	break;	// Be (QRR[h) 
	case PHOTO_MODE_MAX:		sprintf(str, "max");		break;	// Error
	}
}

// ----------------------------------------------------------------------
// SetWhiteBalance
// ----------------------------------------------------------------------
// e
//   zCgoXw肵܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 5̒lw肵܂B
//                    0:I[gzCgoX
//                    1:^OXe(Md)
//                    2:Fu
//                    3:z
//                    4: / [Ă
//                    5:A
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetWhiteBalance(int n)
{
	WhiteBalance mode = WHITE_BALANCE_AUTO;
	switch(n)
	{
	case 0:	mode = WHITE_BALANCE_AUTO;	break;
	case 1:	mode = WHITE_BALANCE_3200K;	break;
	case 2:	mode = WHITE_BALANCE_4150K;	break;
	case 3:	mode = WHITE_BALANCE_5200K;	break;
	case 4:	mode = WHITE_BALANCE_6000K;	break;
	case 5:	mode = WHITE_BALANCE_7000K;	break;
	case 6:	mode = WHITE_BALANCE_MAX;	break;	// error
	default :return;
	}

	nn::camera::CTR::SetWhiteBalance(SELECT_IN1, mode);
}

// ----------------------------------------------------------------------
// GetWhiteBalanceStr
// ----------------------------------------------------------------------
// e
//   zCgoX̕\p擾܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 5̒lw肵܂B
//                    0:I[gzCgoX
//                    1:^OXe(Md)
//                    2:Fu
//                    3:z
//                    4: / [Ă
//                    5:A
//   str		[ O ] 擾i[܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void GetWhiteBalanceStr(int n, char* str)
{
	switch(n)
	{
	case WHITE_BALANCE_AUTO:	sprintf(str, "Normal");			break;	// I[gzCgoX
	case WHITE_BALANCE_3200K:	sprintf(str, "Tungsten");		break;	// ^OXe(Md)
	case WHITE_BALANCE_4150K:	sprintf(str, "WF Light");		break;	// Fu
	case WHITE_BALANCE_5200K:	sprintf(str, "DayLight");		break;	// z
	case WHITE_BALANCE_6000K:	sprintf(str, "Cloudy/Horizon");	break;	//  / [Ă
	case WHITE_BALANCE_7000K:	sprintf(str, "Shade");			break;	// A
	case WHITE_BALANCE_MAX:		sprintf(str, "max  ");			break;	// error
	}
}

// ----------------------------------------------------------------------
// SetAutoWhiteBalance
// ----------------------------------------------------------------------
// e
//   zCgoX@\̗LEݒ肵܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0() / 1(L)w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetAutoWhiteBalance(int n)
{
	bool bSet = (n > 0) ? true: false;
	// ̐ݒlNormal̂Ƃ̂ݐݒ肪\(ȊO͗)
	// Normalɐݒ肷

    nn::camera::CTR::SetWhiteBalance(SELECT_IN1, WHITE_BALANCE_AUTO);

	nn::camera::CTR::SetAutoWhiteBalance(SELECT_IN1, bSet);
}

// ----------------------------------------------------------------------
// SetContrast
// ----------------------------------------------------------------------
// e
//   RgXgw肵܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 11̒lw肵܂B
//                    ftHg6ݒ肳Ă܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetContrast(int n)
{
	Contrast mode = CONTRAST_PATTERN_06;
	switch(n)
	{
	case 0:		mode = CONTRAST_PATTERN_01;	break;
	case 1:		mode = CONTRAST_PATTERN_02;	break;
	case 2:		mode = CONTRAST_PATTERN_03;	break;
	case 3:		mode = CONTRAST_PATTERN_04;	break;
	case 4:		mode = CONTRAST_PATTERN_05;	break;
	case 5:		mode = CONTRAST_PATTERN_06;	break;	// default
	case 6:		mode = CONTRAST_PATTERN_07;	break;
	case 7:		mode = CONTRAST_PATTERN_08;	break;
	case 8:		mode = CONTRAST_PATTERN_09;	break;
	case 9:		mode = CONTRAST_PATTERN_10;	break;
	case 10:	mode = CONTRAST_PATTERN_11;	break;
	case 11:	mode = CONTRAST_MAX;		break;	// error
	default:	return;
	}

	nn::camera::CTR::SetContrast(SELECT_IN1, mode);
}

// ----------------------------------------------------------------------
// GetContrastStr
// ----------------------------------------------------------------------
// e
//   RgXg̕\p擾܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 11̒lw肵܂B
//   str		[ O ] 擾i[܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void GetContrastStr(int n, char* str)
{
	switch(n)
	{
	case CONTRAST_PATTERN_01:	sprintf(str, "Pattern 01");	break;	// p^[01
	case CONTRAST_PATTERN_02:	sprintf(str, "Pattern 02");	break;	// p^[02
	case CONTRAST_PATTERN_03:	sprintf(str, "Pattern 03");	break;	// p^[03
	case CONTRAST_PATTERN_04:	sprintf(str, "Pattern 04");	break;	// p^[04
	case CONTRAST_PATTERN_05:	sprintf(str, "Pattern 05");	break;	// p^[05
	case CONTRAST_PATTERN_06:	sprintf(str, "Pattern 06"); break;	// p^[06
	case CONTRAST_PATTERN_07:	sprintf(str, "Pattern 07");	break;	// p^[07
	case CONTRAST_PATTERN_08:	sprintf(str, "Pattern 08");	break;	// p^[08
	case CONTRAST_PATTERN_09:	sprintf(str, "Pattern 09");	break;	// p^[09
	case CONTRAST_PATTERN_10:	sprintf(str, "Pattern 10");	break;	// p^[10
	case CONTRAST_PATTERN_11:	sprintf(str, "Pattern 11");	break;	// p^[11
	case CONTRAST_MAX:			sprintf(str, "max  ");		break;	// error
	}
}

// ----------------------------------------------------------------------
// SetLensCorrection
// ----------------------------------------------------------------------
// e
//   ӌʔw肵܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 2̒lw肵܂B
//                    0:ӌʔݒOFFɂ
//                    1:ӌʔ䂪70ɂȂ悤ɒ
//                    2:ӌʔ䂪90ɂȂ悤ɒ
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetLensCorrection(int n)
{
	LensCorrection mode = LENS_CORRECTION_OFF;
	switch(n)
	{
	case 0:	mode = LENS_CORRECTION_OFF;		break;	// dark
	case 1:	mode = LENS_CORRECTION_ON_70;	break;	// normal
	case 2:	mode = LENS_CORRECTION_ON_90;	break;	// bright
	case 3:	mode = LENS_CORRECTION_MAX;		break;	// error
	default:	return;
	}

	nn::camera::CTR::SetLensCorrection(SELECT_IN1, mode);
}

// ----------------------------------------------------------------------
// GetLensCorrectionStr
// ----------------------------------------------------------------------
// e
//   ӌʔ̕\p擾܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 2̒lw肵܂B
//   str		[ O ] 擾i[܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void GetLensCorrectionStr(int n, char* str)
{
	switch(n)
	{
	case LENS_CORRECTION_OFF:	sprintf(str, "Dark");	break;	// ӌʔݒOFFɂ
	case LENS_CORRECTION_ON_70:	sprintf(str, "Normal");	break;	// ӌʔ䂪70ɂȂ悤ɒ
	case LENS_CORRECTION_ON_90:	sprintf(str, "Bright");	break;	// ӌʔ䂪90ɂȂ悤ɒ
	case LENS_CORRECTION_MAX:	sprintf(str, "max");	break;	// error
	}
}
