//
//------------------------------------------------------------
// Copyright(c) 2009-2010 by Digital Media Professionals Inc.
// All rights reserved.
//------------------------------------------------------------
// This source code is the confidential and proprietary
// of Digital Media Professionals Inc.
//------------------------------------------------------------
//
//
// VShader.asm
// ̃VF[_OpenGL1.1̒_̌ŒpCvCG~[g
// ̂łBCg1A_Ƃ݂Ȃꍇ̉Zs܂B
//

// Input registers map
#define aPosition       v0
#define aNormal         v1

// Output registers map
#define vPosition       o0

// Constant registers
#define CONSTANT        c93

def     CONSTANT[0], 0.0, 1.0, 2.0, 3.0
def     CONSTANT[1], 0.125, 0.00390625, 0.5, 0.25

#define CONST_0                 CONSTANT[0].x
#define CONST_1                 CONSTANT[0].y
#define CONST_2                 CONSTANT[0].z
#define CONST_3                 CONSTANT[0].w
#define CONST_HALF              CONSTANT[1].z
#define CONST_QUARTER           CONSTANT[1].w
#define CONST_1_0               CONSTANT[0].yx
#define CONST_1__4              CONSTANT[1].w
#define CONST_1__8              CONSTANT[1].x
#define CONST_1__256            CONSTANT[1].y

#pragma bind_symbol( aPosition.xyz, v0, v0 )
#pragma bind_symbol( aNormal.xyz, v1, v1 )

#pragma output_map( position, o0 )
#pragma output_map( color, o1 )

#pragma bind_symbol( uProjection, c0, c3 )
#pragma bind_symbol( uModelView, c4, c7 )
#pragma bind_symbol( uLightPos, c8, c8 )
#pragma bind_symbol( uDiff, c9, c9 )
#pragma bind_symbol( uAmb, c10, c10 )
#pragma bind_symbol( uSpec, c11, c11 )
#pragma bind_symbol( uMatShiniess.x, c12, c12 )

main:
    // IuWFNgWnŐݒ肳ꂽ_W_Wnɕϊ
    // ɃNbvWnւƕϊ܂B
    // r15ɂ͎_Wnɂ钸_ʒui[Ao0ɃNbvWn
    // 钸_ʒuo͂܂B
    m4x4    r15,        v0,         c4
	m4x4    o0,       r15,        c0
    // IuWFNWnŐݒ肳ꂽ@xNg
    // _Wn֕ϊ܂Bł̓fr[}gNX
    // upper-left3x3sgĕϊĂ܂B
    // @̓AvP[VŐKꂽw肳A
    // AϊsɃXP[OĂȂ̂
    // _ł͖@xNg̐K͂ƂɍsĂ܂B
	m3x3    r14.xyz,    v1,       c4
    // KꂽCgxNg쐬܂B
    // r15͎_Wnɂ钸_Wł邽߁A
    // -r15xNg\܂B
    // c8͎_Wnɒu郉CgʒuŎ_Wnւ
    // ϊ̓AvP[VłȂAc8ɐݒ肳Ă܂B
    // ȏc8-r15CgxNgƂȂ܂Bi̎_ł͐K͂ĂȂj
    add     r0,         c8,         -r15
    // ȉ3sr0(CgxNgj̐Ks܂B
    dp3     r0.w,       r0,         r0
    rsq     r0.w,       r0.w
    mul     r0,         r0,         r0.w
    // XyL[̂߂Ƀn[txNg܂B
    // ܂xNg𐳋K̂܂B
    mov     r1,         -r15
    dp3     r1.w,       r1,         r1
    rsq     r1.w,       r1.w
    mul     r1,         r1,         r1.w
    // xNgƃCgxNgZāiCgxNg͐KĂ܂j
    add     r2,         r0,         r1
    // 𐳋K܂Br2Kꂽn[txNgƂȂ܂B
    dp3     r2.w,       r2,         r2
    rsq     r2.w,       r2.w
    mul     r2,         r2,         r2.w
    // NLNHvZ܂B
    // NL͖@ƃCgxNg̓ςr3.xɊi[܂B
    dp3     r3.x,       r14.xyz,    r0
    // NH͖@ƃn[txNg̓ςr3.Ɋi[܂B
    dp3     r3.y,       r14.xyz,    r2
    // NL, NH0ȏŃNv܂B
    max     r3,         r3.xy,      CONST_0
    // NL܂NH̏ꍇ̓XyL[̊^͂ȂƂ݂Ȃ̂
    // NL < 0.0 || NH < 0.0 NHNL0.0ɃNv܂B
    cmp     2,          2,          r3,     CONST_0
    ifc     1,          1,          2
        mov r3.y,       CONST_0
    endif
    // ŏIIȒ_J[̉Zs܂B
    // ܂r10ɃO[oArGgƃCg0̃ArGg̘a
    // i[܂BAvP[VɂāAc10ɂ̘͂aݒ肳Ă܂B
    mov     r10,        c10
    // fBt[Y̊^Z܂B
    mad     r10,        r3.x,       c9,     r10 
    // XyL[̊^Z܂B
    // NHshininessɂĂׂ悵܂B
    // c12.xɂshininessݒ肳Ă܂B
    // ܂ׂvZȂ
    pow     r6,         r3.y,       c12.x
    // XyL[̊^Z܂B
    mad     r10,        r6.x,       c11,    r10
    // o1ɒ_J[ݒ肵܂B
    mov     o1,         r10
    end
endmain:
