// ----------------------------------------------------------------------
// Tv
//   AvP[Vʒ`
// ----------------------------------------------------------------------
#ifndef __APP_DEFINE__
#define __APP_DEFINE__

// ----------------------------------------------------------------------
// BitmapFileHeader
// ----------------------------------------------------------------------
typedef	struct {

	u16			bfType ;
	u16			padd00 ;
	u32			bfSize ;
	u16			bfRsv1 ;
	u16			bfRsv2 ;
	u32			bfBits ;

} BMFH ;

// ----------------------------------------------------------------------
// BitmapInforHeader
// ----------------------------------------------------------------------
typedef	struct {

	u32			biSize ;
	u32			biWdth ;
	u32			biHigh ;
	u16			biPlan ;
	u16			biBitc ;
	u32			biComp ;
	u32			biImag ;
	u32			biXppm ;
	u32			biYppm ;
	u32			biCuse ;
	u32			biCimp ;

} BMIH ;

// ----------------------------------------------------------------------
// Image Info
// ----------------------------------------------------------------------
typedef struct {

	u32			Wdth ;			// Width  of the image (pixel)
	u32			High ;			// Height of the image (pixel)
	u8			Bitc ;			// Number of bit  (bits/pixel)
	u8			Pad0 ;
	u16			Pad1 ;
	u32			Maps ;			// Number of color    (/pixel)
	u32			Xppm ;			// X resolution (pixels/meter)
	u32			Yppm ;			// Y resolution (pixels/meter)

} IMGI ;

#endif // __APP_DEFINE__
