// ----------------------------------------------------------------------
// oʕ\EChENX
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn.h>
#include	<nn/gx.h>
#include	<nn/math.h>
#include	<nn/os.h>
#include	<nn/hid.h>
#include	<nn/fnd.h>
#include	<nn/fs.h>

#include	<string.h>

// ----------------------------------------------------------------------
// include mgr header
// ----------------------------------------------------------------------
#include	"mgr.h"					// mgrwb_[
using namespace mw::mgr;

// ----------------------------------------------------------------------
// include original header
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlGraphics.h"
#include	"CtrlCamera.h"
#include	"TxtWindow.h"
#include	"TxtWinResultMgr.h"

// ----------------------------------------------------------------------
// CTxtWinResultMgr::CTxtWinResultMgr
// ----------------------------------------------------------------------
// e
//   RXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinResultMgr::CTxtWinResultMgr()
	: CTxtWindow("Result")
{

}

// ----------------------------------------------------------------------
// CTxtWinResultMgr::~CTxtWinResultMgr
// ----------------------------------------------------------------------
// e
//   fXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinResultMgr::~CTxtWinResultMgr()
{

}

// ----------------------------------------------------------------------
// CTxtWinResultMgr::Draw
// ----------------------------------------------------------------------
// e
//   Window̕\s܂B
// ----------------------------------------------------------------------
// 
//   graphics		[ I ] OtBbNNXw肵܂B
//   display		[ I ] Window\fBXvCw肵܂B
//   sx				[ I ] Window\XWw肵܂B
//   sy				[ I ] Window\YWw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   0Ԃ܂B
// ----------------------------------------------------------------------
int CTxtWinResultMgr::Draw(CCtrlGraphics* graphics, const s32 display, int sx, int sy)
{
	char		str[64];
	int			n			= 0;
	int			body_num	= m_result.bodynum;
	MGObject*	object		= m_result.mgobject;
	int			lines		= 12;

	if (body_num + 2 > lines)
	{
		lines = body_num + 2; 
	}

	CTxtWindow::SetLines(lines);
	
	sprintf(str, "bodynum:%d\n", body_num);
	CTxtWindow::SetText(0, str, 0.0, 0.0, 0.0);

	sprintf(str, "------------------------------\n");
	CTxtWindow::SetText(1, str, 1.0, 1.0, 1.0);

	for (n = 0 ; n < body_num ; n++)
	{
		sprintf(str, "%d: [%02d] (%3d,%3d)-(%3d,%3d) (%3d,%3d)\n",
			n + 1,
			(s32)object->id,
			object->rect.sx,
			object->rect.sy,
			object->rect.ex,
			object->rect.ey,
			object->center.x,
			object->center.y);

		CTxtWindow::SetText(n + 2, str, 0.0, 0.0, 0.0);
		object++;
	}

	for (; n < 10 ; n++)
	{
		sprintf(str,"%d: [--] (---,---)-(---,---) (---,---)\n", n);
		CTxtWindow::SetText(n + 2, str, 0.0, 0.0, 0.0);
	}

	CTxtWindow::DrawWindow(graphics, display, sx, sy);

	return 0;
}

// ----------------------------------------------------------------------
// CTxtWinResultMgr::UpdateResult
// ----------------------------------------------------------------------
// e
//   ʒl̍XVs܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWinResultMgr::UpdateResult(MGResult* result)
{
	memcpy(&m_result, result, sizeof(MGResult));
}
