// ----------------------------------------------------------------------
// X^[gAbvEChENX
// ----------------------------------------------------------------------
// Nɕ\A[h̑Is
// EQQVGA (160 * 120) /DS LCD (256 * 192)
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn.h>
#include	<nn/gx.h>
#include	<nn/math.h>
#include	<nn/os.h>
#include	<nn/hid.h>
#include	<nn/fnd.h>
#include	<nn/fs.h>

#include	<string.h>

// ----------------------------------------------------------------------
// include original header
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlGraphics.h"
#include	"TxtWindow.h"
#include	"TxtWinStartup.h"

// ----------------------------------------------------------------------
// using namespace
// ----------------------------------------------------------------------
using namespace nn::hid;

// ----------------------------------------------------------------------
// enum
// ----------------------------------------------------------------------
typedef enum
{
	eMENU_SUW_SIZE,
	eMENU_SUW_EXIT
}eMENU_SUW;

// ----------------------------------------------------------------------
// global 
// ----------------------------------------------------------------------
bool g_endflg = false;

// ----------------------------------------------------------------------
// func_end
// ----------------------------------------------------------------------
// e
//   ExitIꂽꍇɌĂяo܂B
//   O[oDoModalItOONɂ܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] gp܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void func_end(int n)
{
	g_endflg = (n != false) ? true : true;
}

// ----------------------------------------------------------------------
// GetSizeStr
// ----------------------------------------------------------------------
// e
//   TCY̕\p擾܂B
// ----------------------------------------------------------------------
// 
//   n			[ I ] 0 ` 1̒lw肵܂B
//   str		[ O ] 擾i[܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void GetSizeStr(int n, char* str)
{
	switch(n)
	{
	case 0: sprintf(str, "QQVGA");	break;
	case 1: sprintf(str, "DS LCD ");	break;
	}
}


// ----------------------------------------------------------------------
// CTxtWinStartup::CTxtWinStartup
// ----------------------------------------------------------------------
// e
//   RXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinStartup::CTxtWinStartup()
	: CTxtWindow("Start up"),
	m_menu(2, "PROC SIZE")
{
	m_menu.SetItemMinMax(0, eMENU_SUW_SIZE, "QQVGA/DS LCD :", 0, 1, 1, NULL);
	m_menu.SetItemExit  (1, eMENU_SUW_EXIT, "Start      ", func_end);

	m_menu.SetItemStrFunc(eMENU_SUW_SIZE, GetSizeStr);

	CTxtWindow::SetForcus(true);
}

// ----------------------------------------------------------------------
// CTxtWinStartup::~CTxtWinStartup
// ----------------------------------------------------------------------
// e
//   fXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinStartup::~CTxtWinStartup()
{

}

// ----------------------------------------------------------------------
// CTxtWinStartup::DoModal
// ----------------------------------------------------------------------
// e
//   Window̕\s܂B
// ----------------------------------------------------------------------
// 
//   graphics		[ I ] OtBbNNXw肵܂B
//   display		[ I ] Window\fBXvCw肵܂B
//   sx				[ I ] Window\XWw肵܂B
//   sy				[ I ] Window\YWw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   0Ԃ܂B
// ----------------------------------------------------------------------
int CTxtWinStartup::DoModal(CCtrlGraphics* graphics, const s32 display, int sx, int sy)
{
	PadReader padReader;
	PadStatus padStatus;
	char str[64];
	int n = 0;

	while(g_endflg == false)
	{
		int menu_num = m_menu.GetCount();

		CTxtWindow::SetLines(menu_num);
		for (n = 0 ; n < menu_num ; n++)
		{
			m_menu.GetItemText(n, str);
			CTxtWindow::SetText(n, str, 1.0, 1.0, 1.0);
		}

		// ----------------------------------------------------------------------
		// Rg[[̏\L[ɂ郁j[̑
		// ----------------------------------------------------------------------
		padReader.ReadLatest(&padStatus);

		//  Button
		if (padStatus.trigger & BUTTON_UP)
		{
			m_menu.SetPrev();
		}

		//  Button
		if (padStatus.trigger & BUTTON_DOWN)
		{
			m_menu.SetNext();
		}

		// A Button ivXj
		if (padStatus.trigger & BUTTON_A)
		{
			m_menu.SetSelect(true);
		}

		// B Button i}CiXj
		if (padStatus.trigger & BUTTON_B)
		{
			m_menu.SetSelect(false);
		}

		graphics->ClearDisplay(display);

		CTxtWindow::DrawWindow(graphics, display, sx, sy);

		graphics->SwapBuffer(display);
	}
	return 0;
}

// ----------------------------------------------------------------------
// CTxtWinStartup::GetStartMode
// ----------------------------------------------------------------------
// e
//   NQQVGA/DS LCDǂ̃[hgp邩Ԃ܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   eSTART_VGA/eSTART_QVGA/eSTART_QQVGA/eSTART_DS_LCD
// ----------------------------------------------------------------------
eSTART_MODE CTxtWinStartup::GetStartMode()
{
	switch(m_menu.GetItemMinMax(eMENU_SUW_SIZE))
	{
	case 0: return eSTART_QQVGA;
	case 1: return eSTART_DS_LCD;
	}

	return eSTART_QVGA;
}

